Check if Arrays can be made equal by Replacing elements with their number of Digits
Last Updated :
02 Feb, 2023
Given two arrays A[] and B[] of length N, the task is to check if both arrays can be made equal by performing the following operation at most K times:
- Choose any index i and either change Ai to the number of digits Ai have or change Bi to the number of digits Bi have.
Examples:
Input: N = 4, K = 1, A = [1, 2, 3, 4], B = [1, 2, 3, 5]
Output: Unequal
Explanation: It is impossible to make both the array equal by performing the following operation:
1st operation on A will change A to [1, 2, 3, 1] as number of digits in 4 is 1. So both the arrays are unequal .
Input: N = 3, K = 3, A = [2, 9, 3], B = [1, 100, 9].
Output: Equal
Explanation: It is possible to make both the array equal by performing the following operations:
1st operation on A will change A to [1, 9, 3] as number of digits in 2 is 1.
2nd operation on B will change B to [1, 3, 9] as number of digits in 100 is 3.
So array A is equal to array B after the operations.
Approach: To solve the problem follow the below idea/Intuition:
Can we make both array similar?
The answer is Yes as we are reducing each number by its length so eventually all numbers in both the array can be 1. The important thing here is to notice that every number greater than 1 always decreases by performing the operation. Thus, if a number appears in only one of the arrays, you will have to do one of the followings two things:
- Decrease some greater number to make it equal to this one.
- Decrease this number.
So, the proposed solution is the following. Consider the largest element in each array. If they are equal, remove both. If not, apply above operation to the larger of them and continue until the arrays are empty. This can be done efficiently using a max heap (priority queue).
Follow the below steps to solve the problem:
- Declare priority queue (max heap) 'First' and push all the elements of A[] on First.
- Declare priority queue (max heap) 'Second' and push all the elements of B[] on Second.
- Initialize the counter variable to 0.
- Start a while loop till any of the queues become empty and check.
- If (First.top() > Second.top()) then pop the top element from First and push the number of digits in that element back to First and increment the counter by 1.
- If (Second.top() > First.top()) then pop the top element from Second and push the number of digits in that element back to Second and increment the counter by 1.
- If ( first.top() = second.top() ) then pop the top elements from both heaps.
- After the iteration is over, If the counter is less than or equal to K, print "Equal", otherwise, print "Unequal"
Below is the implementation of the above approach.
C++
// Code for above approach
#include <bits/stdc++.h>
using namespace std;
// Function calculating number of digit
// of the given element
int len(int x)
{
string temp = to_string(x);
return temp.size();
}
bool canbothEqual(int N, int K, vector<int>& A,
vector<int>& B)
{
// Declaring first priority
// queue MAX HEAP
priority_queue<int> First;
for (int i = 0; i < N; i++) {
// Pushing all the elements of
// array A to the queue
First.push(A[i]);
}
// Declaring second priority queue MAX HEAP
priority_queue<int> Second;
for (int i = 0; i < N; i++) {
// Pushing all the elements of
// array B to the queue
Second.push(B[i]);
}
// Initialising counter variable to 0
int counter = 0;
while (!First.empty() && !Second.empty()) {
int num1 = First.top();
int num2 = Second.top();
// If top element of first queue is
// greater than top element of
// second queue.
if (num1 > num2) {
First.push(len(num1));
First.pop();
counter++;
}
// If top element of second
// queue is greater than top
// element of first queue.
else if (num2 > num1) {
Second.push(len(num2));
Second.pop();
counter++;
}
// If top element of both the
// queue is same
else {
First.pop();
Second.pop();
}
}
// If counter is smaller than or equal
// to K then returning 1
if (K >= counter)
return true;
// Returning 0
return false;
}
// Driver function
int main()
{
int N = 3;
int K = 3;
vector<int> A = { 2, 9, 3 };
vector<int> B = { 1, 100, 9 };
// Function Call
if (canbothEqual(N, K, A, B))
cout << "Equal";
else
cout << "Unequal";
return 0;
}
Java
// Java code for the above approach
import java.util.*;
class GFG {
// Function calculating number of digit
// of the given element
static int len(int x)
{
String temp = String.valueOf(x);
return temp.length();
}
static boolean canbothEqual(int N, int K, int[] A,
int[] B)
{
// Declaring first priority
// queue MAX HEAP
PriorityQueue<Integer> First = new PriorityQueue<>(
(x, y) -> Integer.compare(y, x));
for (int i = 0; i < N; i++) {
// Pushing all the elements of
// array A to the queue
First.add(A[i]);
}
// Declaring second priority queue MAX HEAP
PriorityQueue<Integer> Second = new PriorityQueue<>(
(x, y) -> Integer.compare(y, x));
for (int i = 0; i < N; i++) {
// Pushing all the elements of
// array B to the queue
Second.add(B[i]);
}
// Initialising counter variable to 0
int counter = 0;
while (First.size() != 0 && Second.size() != 0) {
int num1 = First.peek();
int num2 = Second.peek();
// If top element of first queue is
// greater than top element of
// second queue.
if (num1 > num2) {
First.add(len(num1));
First.poll();
counter++;
}
// If top element of second
// queue is greater than top
// element of first queue.
else if (num2 > num1) {
Second.add(len(num2));
Second.poll();
counter++;
}
// If top element of both the
// queue is same
else {
First.poll();
Second.poll();
}
}
// If counter is smaller than or equal
// to K then returning 1
if (K >= counter)
return true;
// Returning 0
return false;
}
// Driver function
public static void main(String[] args)
{
int N = 3;
int K = 3;
int[] A = { 2, 9, 3 };
int[] B = { 1, 100, 9 };
// Function Call
if (canbothEqual(N, K, A, B))
System.out.println("Equal");
else
System.out.println("Unequal");
}
}
// This code is contributed by Potta Lokesh
Python3
# Python code for the above approach
from queue import PriorityQueue
def canbothEqual(N, K, A, B):
# Declaring first priority
# queue MAX HEAP
First = PriorityQueue()
for i in range(N):
# Pushing all the elements of
# array A to the queue
First.put(A[i])
# Declaring second priority queue MAX HEAP
Second = PriorityQueue()
for i in range(N):
# Pushing all the elements of
# array B to the queue
Second.put(B[i])
# Initialising counter variable to 0
counter = 0
while (First.empty() == False and Second.empty() == False):
num1 = First.get()
num2 = Second.get()
# If top element of first queue is
# greater than top element of
# second queue.
if (num1 > num2):
First.put(len(str(num1)))
nn = First.get()
counter += 1
# If top element of second
# queue is greater than top
# element of first queue.
elif (num2 > num1):
Second.put(len(str(num2)))
cc = Second.get()
counter += 1
# If top element of both the
# queue is same
else:
cc = First.get()
nn = Second.get()
# If counter is smaller than or equal
# to K then returning 1
if (K >= counter):
return True
# Returning 0
return False
# Driver function
if __name__ == "__main__":
N = 3
K = 3
A = [2, 9, 3]
B = [1, 100, 9]
# Function Call
if (canbothEqual(N, K, A, B)):
print("Equal")
else:
print("Unequal")
# This code is contributed by Rohit Pradhan
C#
// C# code for the above approach
using System;
using System.Collections.Generic;
class Program {
// Function calculating number of digit
// of the given element
static int len(int x)
{
string temp = x.ToString();
return temp.Length;
}
static bool canbothEqual(int N, int K, int[] A, int[] B)
{
// Declaring first priority
// queue MAX HEAP
List<int> First = new List<int>();
for (int i = 0; i < N; i++) {
// Pushing all the elements of
// array A to the queue
First.Add(A[i]);
}
// Declaring second priority queue MAX HEAP
List<int> Second = new List<int>();
for (int i = 0; i < N; i++) {
// Pushing all the elements of
// array B to the queue
Second.Add(B[i]);
}
// Initialising counter variable to 0
int counter = 0;
while (First.Count != 0 && Second.Count != 0) {
First.Sort((a, b) => b.CompareTo(a));
Second.Sort((a, b) => b.CompareTo(a));
int num1 = First[0];
int num2 = Second[0];
// If top element of first queue is
// greater than top element of
// second queue.
if (num1 > num2) {
First.Add(len(num1));
First.RemoveAt(0);
counter++;
}
// If top element of second
// queue is greater than top
// element of first queue.
else if (num2 > num1) {
Second.Add(len(num2));
Second.RemoveAt(0);
counter++;
}
// If top element of both the
// queue is same
else {
First.RemoveAt(0);
Second.RemoveAt(0);
}
}
// If counter is smaller than or equal
// to K then returning 1
if (K >= counter)
return true;
// Returning 0
return false;
}
// Driver function
static void Main(string[] args)
{
int N = 3;
int K = 3;
int[] A = { 2, 9, 3 };
int[] B = { 1, 100, 9 };
// Function Call
if (canbothEqual(N, K, A, B))
Console.WriteLine("Equal");
else
Console.WriteLine("Unequal");
}
}
// This code is contributed by Tapesh(tapeshdua420)
JavaScript
<script>
// Priority Queue Implementation in Javascript
function PriorityQueue () {
this.collection = [];
this.printCollection = function() {
console.log(this.collection);
};
this.enqueue=function(item){
if(this.collection.length===0) {
this.collection.push(item);
}
else if(this.collection.length===1){
if(item[1]>=this.collection[0][1]){
this.collection.push(item);
}
else if(item[1]<this.collection[0][1]){
this.collection.unshift(item);
}
}
else if(this.collection.length>1){
let check=false;
for(let i=0;i<this.collection.length;i++){
if(this.collection[i][1]>item[1]){
if(i===0){
check=true;
this.collection.unshift(item);
break;
}
else {
check=true;
let sliced=this.collection.slice(0,i);
let slicedend=this.collection.slice(i,this.collection.length);
sliced.push(item);
this.collection=sliced.concat(slicedend);
break;
}
}
}
if(!check){
this.collection.push(item);
}
};
this.dequeue = function(){
return this.collection.shift()[0];
};
this.size = function(){
return this.collection.length;
};
this.isEmpty=function(){
return this.collection.length===0?true:false;
};
this.front=function(){
return this.collection[0];
};
}
}
// Code for above approach
// Function calculating number of digit
// of the given element
function len(x)
{
let temp = String(x);
return temp.length;
}
function canbothEqual(N, K, A, B)
{
// Declaring first priority
// queue MAX HEAP
let First = new PriorityQueue();
// priority_queue<int> First;
for (let i = 0; i < N; i++) {
// Pushing all the elements of
// array A to the queue
First.enqueue(A[i]);
}
// Declaring second priority queue MAX HEAP
let Second = new PriorityQueue();
// priority_queue<int> Second;
for (let i = 0; i < N; i++) {
// Pushing all the elements of
// array B to the queue
Second.enqueue(B[i]);
}
// Initialising counter variable to 0
let counter = 0;
while (!First.isEmpty() && !Second.isEmpty()) {
let num1 = First.front();
let num2 = Second.front();
// If top element of first queue is
// greater than top element of
// second queue.
if (num1 > num2) {
First.enqueue(len(num1));
First.dequeue();
counter++;
}
// If top element of second
// queue is greater than top
// element of first queue.
else if (num2 > num1) {
Second.enqueue(len(num2));
Second.dequeue();
counter++;
}
// If top element of both the
// queue is same
else {
First.dequeue();
Second.dequeue();
}
}
// If counter is smaller than or equal
// to K then returning 1
if (K >= counter)
return true;
// Returning 0
return false;
}
// Driver function
N = 3;
K = 3;
let A = [ 2, 9, 3 ];
let B = [ 1, 100, 9 ];
// Function Call
if (canbothEqual(N, K, A, B))
console.log("Equal");
else
console.log("Unequal");
// This code is contributed by akashish__
</script>
Time Complexity: O(N * log(N))
Auxiliary Space: O(N)
Similar Reads
Check if Array elements can be made equal by adding unit digit to the number
Given an array arr[] of N integers, the task is to check whether it is possible to make all the array elements identical by applying the following option any number of times: Choose any number and add its unit digit to it. Examples: Input: arr[] = {1, 2, 4, 8, 24}Output: PossibleExplanation: For 1:
7 min read
Check if Array Elemnts can be Made Equal with Given Operations
Given an array arr[] consisting of N integers and following are the three operations that can be performed using any external number X. Add X to an array element once.Subtract X from an array element once.Perform no operation on the array element.Note : Only one operation can be performed on a numbe
6 min read
Check if all array elements can be converted to pronic numbers by rotating digits
Given an array arr[] of size N, the task is to check if it is possible to convert all of the array elements to a pronic number by rotating the digits of array elements any number of times. Examples: Input: {321, 402, 246, 299} Output: True Explanation: arr[0] ? Right rotation once modifies arr[0] to
7 min read
Check if sum of array can be made equal to X by removing either the first or last digits of every array element
Given an array arr[] consisting of N positive integers and a positive integer X, the task is to check if the sum of the given array can be made equal to X by removing either the first or last digit of every array element. If it is possible to make the sum of array elements equal to X, then print "Ye
7 min read
Make Array elements equal by replacing adjacent elements with their XOR
Given an array A[] consisting of N integers, the task is to check if it is possible to reduce array of at least length 2 such that all the elements in the array are equal. In an operation, choose any index i, and replace A[i] and A[i+1] with their XOR value. Example: Input: A[] = {0, 2, 2}Output: YE
14 min read
Javascript Program to Check if all array elements can be converted to pronic numbers by rotating digits
Given an array arr[] of size N, the task is to check if it is possible to convert all of the array elements to a pronic number by rotating the digits of array elements any number of times. Examples: Input: {321, 402, 246, 299} Output: True Explanation: arr[0] ? Right rotation once modifies arr[0] to
3 min read
Check if any subarray can be made palindromic by replacing less than half of its elements
Given an array arr[] of size N, the task is to check if any subarray from the given array can be made a palindrome by replacing less than half of its elements (i.e. floor[length/2]) by any other element of the subarray. Examples: Input: arr[] = {2, 7, 4, 6, 7, 8}Output: YesExplanation: Among all sub
7 min read
Check if a number can be represented as the sum of numbers with at least one digit equal to K
Given integers N and K, the task is to check if a number can be represented as the sum of numbers that have at least one digit equal to K. Example: Input: N = 68, K = 7Output: YESExplanation: 68 = (27 + 17 + 17 + 7). Each number has atleast one digit equal to 7. Input: N = 23, K = 3Output: YESExplan
6 min read
Check if array elements can become same using one external number
Given an array arr[] consisting of N integers and following are the three operations that can be performed using any external number X:Add X to an array element once.Subtract X from an array element once.Perform no operation on the array element.The task is to check whether there exists a number X,
11 min read
Check if two arrays can be made equal by reversing any subarray once
Given two arrays A[] and B[] of equal size N, the task is to check whether A[] can be made equal to B[] by reversing any sub-array of A only once. Examples: Input: A[] = {1, 3, 2, 4} B[] = {1, 2, 3, 4} Output: Yes Explanation: The sub-array {3, 2} can be reversed to {2, 3}, which makes A equal to B.
8 min read